#include <xc.h>
#include <stdio.h>
#include "uart.h"

#define _XTAL_FREQ 32000000    //  delay$BMQ$KI,MW(B($B%/%m%C%/(B8MHz$B$r;XDj(B)

// $B%3%s%U%#%.%e%l!<%7%g%s#1$N@_Dj(B
#pragma config FOSC = INTOSC//$BFbIt(I8[/8$B;HMQ$9$k(B(FOSC_INTOSC)
#pragma config PLLEN = ON//$BF0:n%/%m%C%/$r(B32MHz$B$GF0:n(B
#pragma config FCMEN = OFF//$B30It(I8[/8$B4F;k$7$J$$(B(FCMEN_OFF)
#pragma config IESO = OFF//$B30It!&FbIt(I8[/8$B$N@ZBX$($G$N5/F0$O$J$7(B(IESO_OFF)
#pragma config BOREN = ON//$BEE8;EE059_2<>o;~4F;k5!G=(BON(BOREN_ON)
#pragma config PWRTE = ON//$BEE8;(BON$B$+$i(B64ms$B8e$K(IL_[8^WQ$B$r3+;O$9$k(B(PWRTEN_ON)
#pragma config WDTE = OFF//(I35/AD^/8^@2O0$BL5$7(B(WDTE_OFF)
#pragma config MCLRE = ON//$B30It(IX>/D$B?.9f;HMQ(B
#pragma config CP = ON//(IL_[8^WQRSX0$B$rJ]8n(B(CP_ON)
#pragma config CPD = OFF//(IC^0@RSX0$B$rJ]8n$7$J$$(B(CPD_OFF)

// $B%3%s%U%#%.%e%l!<%7%g%s#2$N@_Dj(B
#pragma config STVREN = ON//$B%9%?%C%/$,%*!<%P%U%m!<$d%"%s%@!<%U%m!<$7$?$i%j%;%C%H$r$9$k(B(STVREN_ON)
#pragma config LVP = OFF//$BDcEE05%W%m%0%i%_%s%05!G=;HMQ$7$J$$(B(LVP_OFF)
#pragma config WRT = OFF//Flash(IRSX0$B$rJ]8n$7$J$$(B(WRT_OFF)
#pragma config BORV = HI//$BEE8;EE059_2<>o;~4F;kEE05(B(2.5V)$B@_Dj(B(BORV_HI)

void startup();

static unsigned int count1;	//
static bit usart_flg = 0;
char get_char;

//$B3d$j9~$_(B
void interrupt isr(void){

    //$B%7%j%"%k(B
    if(RCIF == 1){
        RCIF = 0;

        get_char = RCREG;
        usart_flg = 1;
    }

    //$B%?%$%^!<(B0
    if(INTCONbits.TMR0IF == 1) {
       INTCONbits.TMR0IF = 0;

       count1--;
       if(count1 == 0) {
            count1 = 1000;

            PORTCbits.RC2 = !PORTCbits.RC2;   // LED$BE@LG(B
        }
    }
}

void startup(){

    //$B%/%m%C%/@_Dj(B
    OSCCON     = 0b11110000 ; // $BFbIt%/%m%C%/$O(B8$B#M#H#z$H$9$k(B
    //$BF~=PNO@_Dj(B
    ANSELA     = 0b00000011 ; // $B%"%J%m%0$O;HMQ$7$J$$!J$9$Y$F%G%8%?%k(BI/O$B$K3dEv$F$k!K(B
    TRISA      = 0b00000000 ; //PORT1
    TRISB      = 0b00000000 ; //
    TRISC      = 0b10011000 ; //RC3$B!"(B4$B$O(BI2C$B!"(BRC7$B$O(BRX
    TRISD      = 0b00000000 ; //PORT1
    TRISE      = 0b00000000 ; //PORT2
    TRISF      = 0b00000000 ; //PORT2
    TRISG      = 0b00100100 ; //RG2$B$O(BRX$B!"(BRG5$B$O(BMCLR
    //$B=PNO=i4|CM(B
    PORTA = 0b00000000;    //
    PORTB = 0b00000000;    //
    PORTC = 0b00000000;    //
    PORTD = 0b00000000;    //
    PORTE = 0b00000000;    //
    PORTF = 0b00000000;    //
    PORTG = 0b00000000;    //

    //$B3d$j9~$_@_Dj(B
    OPTION_REG = 0x80;// $B%W%j%9%1!<%i(B 1/2
    //OPTION_REG = 0x84;// $B%W%j%9%1!<%i(B 1/32
    //OPTION_REG = 0x87;	// $B%W%j%9%1!<%i(B 1/256

    TMR0 = 0x00;
    RCIE = 1;   // enable USART interruption
    T0IE = 1;	// TMR0$B3d$j9~$_5v2D(B
    GIE = 1;	// $BA4BN3d$j9~$_5v2D(B


     //PORTBbits.RB0 = 1;

     initUART();             // $BD4JbF14|<0%7%j%"%kDL?.@_Dj(B

     __delay_ms(200);

     printf("start\r\n");
}

void main(){

    startup();

     while(1) {

        //work = getch();
        if(usart_flg == 1){
            usart_flg = 0;

            printf("Echo: %c\r\n",get_char);
            PORTB = get_char;// & 0x01;
        }


        /*
        PORTB = 0b01010101;    // LED0$BE@Et(B
        __delay_ms(1000);          // 500mSec$B$NCY1d(B
        PORTB = 0b10101010;    // LED1$BE@Et(B
        __delay_ms(1000);
        */
    }
}